<template>
  <a-trigger
    trigger="focus"
    auto-fit-position
    :position="position"
    :popup-offset="popupOffset"
    show-arrow
    arrow-class="arco-vue-x-pwd-arrow"
  >
    <div class="arco-vue-x-pwd-wrap">
      <slot />

      <Transition name="fade">
      <div class="arco-vue-x-pwd-stength" v-if="showPwdStrength">
        <span class="arco-vue-x-pwd-stength-title">{{
          locale.pwdStrength
        }}</span>
        <div class="arco-vue-x-pwd-stength-tude">
          <span
            class="arco-vue-x-pwd-stength-tude-info"
            :style="`color: ${current.color}`"
            >{{ current.text }}</span
          >
          <div
            v-for="(item, index) in tudeList"
            class="arco-vue-x-pwd-stength-tude-block"
            :style="`background-color:${item}`"
            :key="index"
          ></div>
        </div>
      </div>
      </Transition>
    </div>
    <template #content>
      <div class="arco-vue-x-pwd-content">
        <div class="arco-vue-x-pwd-list">
          <div
            v-for="({ isSuccess, label, tooltip }, index) in list"
            :key="index"
            class="arco-vue-x-pwd-list-item"
          >
            <icon-check-circle-fill
              class="arco-vue-x-pwd-list-item-icon"
              v-if="isSuccess"
              style="color: rgb(var(--primary-6))"
            />
            <icon-exclamation-circle-fill
              class="arco-vue-x-pwd-list-item-icon"
              v-else
            />
            <span class="arco-vue-x-pwd-list-item-txt">{{ label }}</span>
            <a-tooltip v-if="tooltip" :content="tooltip">
              <icon-question-circle />
            </a-tooltip>
          </div>
        </div>
      </div>
    </template>
  </a-trigger>
</template>

<script lang="ts" setup name="x-pwd">
import { computed } from 'vue'
import { useLocale } from '@arco-vue-x/utils'
import { en, zhCN, zhTW, ru } from './lang'
import { ICheck, ILocale, IStatus, judgePwdStrength } from './help'

const { locale } = useLocale<ILocale>({ en, zhCN, zhTW, ru })

const props = withDefaults(
  defineProps<{
    list: ICheck[];
    value: string;
    showStrengthOnValidation?: boolean;
    popupOffset?: number;
    position?:
      | 'top'
      | 'tl'
      | 'tr'
      | 'bottom'
      | 'bl'
      | 'br'
      | 'left'
      | 'lt'
      | 'lb'
      | 'right'
      | 'rt'
      | 'rb';
  }>(),
  {
    value: '',
    showStrengthOnValidation: true,
    popupOffset: 0
  }
)
const current = computed(
  () =>
    ({
      [IStatus.normal]: {
        text: '',
        number: 0,
        color: 'var(--color-text-2)'
      },
      [IStatus.danger]: {
        number: 1,
        text: locale.value.low,
        color: 'rgb(var(--danger-6))'
      },
      [IStatus.warn]: {
        number: 2,
        text: locale.value.medium,
        color: 'rgb(var(--warning-5))'
      },
      [IStatus.success]: {
        number: 3,
        text: locale.value.high,
        color: 'rgb(var(--success-6))'
      }
    }[judgePwdStrength(props.value)])
)

const tudeList = computed(() => {
  const { number, color } = current.value
  return Array(number)
    .fill(color)
    .concat(Array(3 - number).fill('var(--color-text-2)'))
})

const list = computed(() =>
  (props.list || [])?.map(({ fn, label, tooltip }) => ({
    isSuccess: props.value && fn(props.value),
    tooltip,
    label
  }))
)

const showPwdStrength = computed(() =>
  props.showStrengthOnValidation
    ? list.value.every((item) => item.isSuccess) && !!props.value
    : !!props.value
)
</script>

<style lang="less">
.arco-vue-x-pwd-arrow {
  border: 1px solid var(--color-neutral-3);
  z-index: 1 !important;
}
</style>
<style scoped lang="less">
.arco-vue-x-pwd {
  &-wrap {
    width: 100%;
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    justify-content: flex-start;
  }
  &-content {
    border: 1px solid var(--color-neutral-3);
    max-width: 820px;
    min-width: 30px;
    padding: 12px 16px;
    color: #1f2329;
    box-sizing: border-box;
    width: max-content;
    text-decoration: none;
    word-wrap: break-word;
    background-color: #fff;
    border-radius: 8px;
    box-shadow: 0 8px 24px 8px rgba(31, 35, 41, 0.04),
      0 6px 12px rgba(31, 35, 41, 0.04), 0 4px 8px -8px rgba(31, 35, 41, 0.06);
    position: relative;
    overflow: hidden;
  }

  &-list {
    display: flex;
    flex-direction: column;
    padding: 4px 12px;
    color: #646a73;

    &-item {
      &-icon {
        margin-right: 4px;
      }

      &-txt {
      }
    }
  }

  &-stength {
    padding: 4px 0px;
    display: flex;
    &-title {
    }

    &-tude {
      display: flex;
      align-items: center;
      &-info {
      }

      &-block {
        margin-left: 2px;
        width: 21px;
        height: 4px;
      }
    }
  }
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s ease;
}

.fade-enter-from,
.fade-leave-to {
  opacity: 0;
}
</style>
